"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = applyExtras;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function applyExtras(FormComponent) {
  var FormWithExtras = function (_Component) {
    _inherits(FormWithExtras, _Component);

    function FormWithExtras(props) {
      _classCallCheck(this, FormWithExtras);

      return _possibleConstructorReturn(this, (FormWithExtras.__proto__ || Object.getPrototypeOf(FormWithExtras)).call(this, props));
    }

    _createClass(FormWithExtras, [{
      key: "render",
      value: function render() {
        var registry = (0, _utils.getRegistry)();

        var fields = this.createFieldsObject(this.props.externalFieldInstanceData, registry);
        var allFields = Object.assign({}, fields, this.props.fields);

        var configs = Object.assign({}, this.props, { fields: allFields });

        return _react2.default.createElement(FormComponent, configs);
      }
    }, {
      key: "createFieldsObject",
      value: function createFieldsObject(externalFieldInstanceData, registry) {
        var fields = {};

        for (var externalFieldInstance in externalFieldInstanceData) {
          if (externalFieldInstanceData.hasOwnProperty(externalFieldInstance)) {
            var fieldInstanceDefinition = externalFieldInstanceData[externalFieldInstance];
            var typeClass = registry.fields[fieldInstanceDefinition.type];

            fields[externalFieldInstance] = this.fieldObjFactory(typeClass, fieldInstanceDefinition.data);
          }
        }

        return fields;
      }
    }, {
      key: "fieldObjFactory",
      value: function fieldObjFactory(FieldClass, data) {
        function CustomField(props) {
          return _react2.default.createElement(FieldClass, _extends({}, props, { data: data }));
        }

        return CustomField;
      }
    }, {
      key: "createWidgetObject",
      value: function createWidgetObject(widgetData) {
        /*const widgets = {
          asyncTypeaheadWidget: this.widgetObjFactory(AsyncTypeaheadWidget, widgetData.asyncTypeaheadWidgetData),
          asyncTableWidget: this.widgetObjFactory(AsyncTableWidget, widgetData.asyncTableWidgetData),
          asyncComplexTypeaheadWidget: this.widgetObjFactory(AsyncComplexTypeaheadWidget, widgetData.asyncComplexTypeaheadWidgetData)
        };*/

        var widgets = {};
        return widgets;
      }
    }, {
      key: "widgetObjFactory",
      value: function widgetObjFactory(WidgetClass, widgetData) {
        function CustomWidget(props) {
          return _react2.default.createElement(WidgetClass, _extends({}, props, { widgetData: widgetData }));
        }

        return CustomWidget;
      }
    }]);

    return FormWithExtras;
  }(_react.Component);

  return FormWithExtras;
}